require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__X86_64_MMU_CONTEXT_H)) {
    eval 'sub __X86_64_MMU_CONTEXT_H () {1;}' unless defined(&__X86_64_MMU_CONTEXT_H);
    require 'linux/config.ph';
    require 'asm/desc.ph';
    require 'asm/atomic.ph';
    require 'asm/pgalloc.ph';
    require 'asm/pda.ph';
    require 'asm/pgtable.ph';
    require 'linux/spinlock.ph';
    eval 'sub destroy_context {
        local($mm) = @_;
	    eval q( &do { }  &while(0));
    }' unless defined(&destroy_context);
    eval 'sub init_new_context {
        local($tsk,$mm) = @_;
	    eval q(({  &rwlock_init(($mm)-> ($context->{ldtlock})); 0; }));
    }' unless defined(&init_new_context);
    if(defined(&CONFIG_SMP)) {
    } else {
    }
    eval 'sub activate_mm {
        local($prev, $next) = @_;
	    eval q( &switch_mm(($prev),($next), &NULL, &smp_processor_id()));
    }' unless defined(&activate_mm);
    if(defined(&CONFIG_SMP)) {
    }
    if(defined(&CONFIG_SMP)) {
    }
}
1;
