require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_MMZONE_H_)) {
    eval 'sub _ASM_MMZONE_H_ () {1;}' unless defined(&_ASM_MMZONE_H_);
    require 'linux/config.ph';
    eval 'sub MAXNODE () {8;}' unless defined(&MAXNODE);
    eval 'sub MAX_NUMNODES () { &MAXNODE;}' unless defined(&MAX_NUMNODES);
    eval 'sub NODEMAPSIZE () {0xff;}' unless defined(&NODEMAPSIZE);
    if(0) {
	eval 'sub VIRTUAL_BUG_ON {
	    local($x) = @_;
    	    eval q( &do {  &if  &out_of_line_bug(); }  &while(0));
	}' unless defined(&VIRTUAL_BUG_ON);
    } else {
	eval 'sub VIRTUAL_BUG_ON {
	    local($x) = @_;
    	    eval q( &do {}  &while (0));
	}' unless defined(&VIRTUAL_BUG_ON);
    }
    eval 'sub PLAT_NODE_DATA {
        local($n) = @_;
	    eval q(( $plat_node_data[($n)]));
    }' unless defined(&PLAT_NODE_DATA);
    eval 'sub PLAT_NODE_DATA_STARTNR {
        local($n) = @_;
	    eval q(( &PLAT_NODE_DATA($n)-> ($gendata->{node_start_mapnr})));
    }' unless defined(&PLAT_NODE_DATA_STARTNR);
    eval 'sub PLAT_NODE_DATA_SIZE {
        local($n) = @_;
	    eval q(( &PLAT_NODE_DATA($n)-> ($gendata->{node_size})));
    }' unless defined(&PLAT_NODE_DATA_SIZE);
    eval 'sub PLAT_NODE_DATA_LOCALNR {
        local($p, $n) = @_;
	    eval q(((($p) -  &PLAT_NODE_DATA($n)-> ($gendata->{node_start_paddr})) >>  &PAGE_SHIFT));
    }' unless defined(&PLAT_NODE_DATA_LOCALNR);
    if(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub KVADDR_TO_NID {
	    local($kaddr) = @_;
    	    eval q( &phys_to_nid( &__pa($kaddr)));
	}' unless defined(&KVADDR_TO_NID);
	eval 'sub NODE_DATA {
	    local($n) = @_;
    	    eval q(((( &PLAT_NODE_DATA($n))-> &gendata)));
	}' unless defined(&NODE_DATA);
	eval 'sub NODE_MEM_MAP {
	    local($nid) = @_;
    	    eval q(( &NODE_DATA($nid)-> &node_mem_map));
	}' unless defined(&NODE_MEM_MAP);
	eval 'sub ADDR_TO_MAPBASE {
	    local($kaddr) = @_;
    	    eval q( &NODE_MEM_MAP( &KVADDR_TO_NID(($kaddr))));
	}' unless defined(&ADDR_TO_MAPBASE);
	eval 'sub LOCAL_BASE_ADDR {
	    local($kaddr) = @_;
    	    eval q(( &__va( &NODE_DATA( &KVADDR_TO_NID($kaddr))-> &node_start_paddr)));
	}' unless defined(&LOCAL_BASE_ADDR);
	eval 'sub LOCAL_MAP_NR {
	    local($kvaddr) = @_;
    	    eval q(((($kvaddr)- &LOCAL_BASE_ADDR($kvaddr)) >>  &PAGE_SHIFT));
	}' unless defined(&LOCAL_MAP_NR);
	eval 'sub BAD_PAGE () {0xffffffffffff;}' unless defined(&BAD_PAGE);
	eval 'sub virt_to_page {
	    local($kaddr) = @_;
    	    eval q(({ \'struct page\' * &lmemmap; \'unsigned long lpfn\' =  &paddr_to_local_pfn( &__pa($kaddr), &lmemmap,0);  &lmemmap +  &lpfn; }));
	}' unless defined(&virt_to_page);
	eval 'sub pte_page {
	    local($pte) = @_;
    	    eval q(({ \'struct page\' * &lmemmap; \'unsigned long addr\' =  &pte_val($pte) &  &PHYSICAL_PAGE_MASK; \'unsigned long lpfn\' =  &paddr_to_local_pfn( &addr, &lmemmap,1);  &lmemmap +  &lpfn; }));
	}' unless defined(&pte_page);
	eval 'sub pfn_to_page {
	    local($pfn) = @_;
    	    eval q( &virt_to_page( &__va(($pfn) <<  &PAGE_SHIFT)));
	}' unless defined(&pfn_to_page);
	eval 'sub page_to_pfn {
	    local($page) = @_;
    	    eval q(({ \'int\'  &nodeid =  &phys_to_nid( &__pa($page));  &plat_pg_data_t * &nd =  &PLAT_NODE_DATA( &nodeid); ($page -  ($nd->{gendata}->{node_mem_map})) +  ($nd->{start_pfn}); }));
	}' unless defined(&page_to_pfn);
	eval 'sub VALID_PAGE {
	    local($page_ptr) = @_;
    	    eval q(({ \'int\'  &ok = 0; \'unsigned long phys\' =  &__pa($page_ptr); \'unsigned long index\' =  &phys >>  &memnode_shift;  &if ( &index <=  &NODEMAPSIZE) { \'unsigned nodeid\' =  $memnodemap[ &index];  &pg_data_t * &nd =  &NODE_DATA( &nodeid); \'struct page\' * &lmemmap =  ($nd->{node_mem_map});  &ok = ( &nodeid != 0xff)  && ($page_ptr >=  &lmemmap  && $page_ptr <  &lmemmap +  ($nd->{node_size})); }  &ok; }));
	}' unless defined(&VALID_PAGE);
	eval 'sub page_to_phys {
	    local($page) = @_;
    	    eval q(( &page_to_pfn($page) <<  &PAGE_SHIFT));
	}' unless defined(&page_to_phys);
	if(defined(&CONFIG_NUMA)) {
	    eval 'sub cputonode {
	        local($cpu) = @_;
    		eval q(( &fake_node ? 0: ($cpu)));
	    }' unless defined(&cputonode);
	    eval 'sub numa_node_id () {
	        eval q( &cputonode( &smp_processor_id()));
	    }' unless defined(&numa_node_id);
	}
	eval 'sub MAX_NR_NODES () {8;}' unless defined(&MAX_NR_NODES);
    }
}
1;
